package com.sunyard.ssp.common.constant;

/**
 * @author:tsz
 * @date:2020/4/14
 * @description: 正则规则
 */
public interface RegexConstant {

    /**
    *@author ：tsz
    *@date   ：2020/04/14 16:48
    *@description : 节点编号
    */
    String NODE_NUMBER = "\\d{6,12}";
    
    /**
    *@author ：tsz
    *@date   ：2020/04/14 16:49
    *@description : 方案编号
    */
    String KEY_SOLUTION_NUMBER = "[A-Z][A-Z0-9]{2,5}";

    /**
    *@author ：tsz
    *@date   ：2020/04/14 16:50
    *@description : 模板编号
    */
    String TMPL_NUMBER = "[A-Z][A-Z0-9]{2,5}";

    /**
    *@author ：tsz
    *@date   ：2020/04/14 16:52
    *@description : 密钥名称
    */
    String KEY_NAME = "[A-Z][A-Z0-9]{2,5}";

    /**
    *@author ：tsz
    *@date   ：2020/04/15 10:37
    *@description : 普通名称校验规则 1-15位的字符
    */
    String COMMON_NAME = "^.{1,30}$";

    /**
     *@author ：tsz
     *@date   ：2020/04/15 10:37
     *@description : 普通名称校验规则 1-30位的数字，字母，汉字 备用，暂时没有用
     */
    String COMMON_NAME_TEST = "^[\\w\\u4e00-\\u9fa5]{2,30}$";
    /**
    *@date   :2020/05/22 15:47
    *@description : 加密机名称校验
    */
    String DEVICE_NAME = "^.{1,15}$";
    /**
     *@date   :2020/05/22 15:47
     *@description : 加密机编号校验
     */
    String DEVICE_NUMBER = "^[1-9]\\d*$";
    /**
     *@date   :2020/05/22 15:47
     *@description : 加密机ipv4校验
     */
    String DEVICE_IPV4 = "^((2[0-4]\\d|25[0-5]|[01]?\\d\\d?)\\.){3}(2[0-4]\\d|25[0-5]|[01]?\\d\\d?)$";
    /**
     *@date   :2020/05/22 15:47
     *@description : 加密机ipv6校验
     */
    String DEVICE_IPV6 = "^\\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:)))(%.+)?\\s*$";

    /**
     *@date   :2020/05/22 15:47
     *@description : 加密机端口号校验
     */
    String DEVICE_PORT = "^([0-9]|[1-9]\\d{1,3}|[1-5]\\d{4}|6[0-5]{2}[0-3][0-5])$";

    /**
     *@date   :2020/05/22 15:47
     *@description : 加密机设备型号校验
     */
    String DEVICE_MODEL= "^.{1,15}$";

    /**
     *@date   :2020/05/22 15:47
     *@description : 加密机资产类型校验
     */
    String DEVICE_ASSETTYPE= "^.{1,15}$";

    /**
    *@date   : 2020:05:28 13:52
    *@description : 证书检测是否是base64加密的
    */
    String CERTIFICATE_CONTENT = "[-]{5}BEGIN[\\s]*[\\w\\s]*[-]{5}[\\s]*[a-zA-Z\\d\\s/+]*[=]{0,2}[\\s]*[-]{5}END[\\s]*[\\w\\s]*[-]{5}[\\s]*";

}
